<HTML>
<BODY BGCOLOR="white">
<PRE>
<FONT color="green">001</FONT>    /*<a name="line.1"></a>
<FONT color="green">002</FONT>     * =============================================================================<a name="line.2"></a>
<FONT color="green">003</FONT>     * Simplified BSD License, see http://www.opensource.org/licenses/<a name="line.3"></a>
<FONT color="green">004</FONT>     * -----------------------------------------------------------------------------<a name="line.4"></a>
<FONT color="green">005</FONT>     * Copyright (c) 2008-2009, Marco Terzer, Zurich, Switzerland<a name="line.5"></a>
<FONT color="green">006</FONT>     * All rights reserved.<a name="line.6"></a>
<FONT color="green">007</FONT>     * <a name="line.7"></a>
<FONT color="green">008</FONT>     * Redistribution and use in source and binary forms, with or without <a name="line.8"></a>
<FONT color="green">009</FONT>     * modification, are permitted provided that the following conditions are met:<a name="line.9"></a>
<FONT color="green">010</FONT>     * <a name="line.10"></a>
<FONT color="green">011</FONT>     *     * Redistributions of source code must retain the above copyright notice, <a name="line.11"></a>
<FONT color="green">012</FONT>     *       this list of conditions and the following disclaimer.<a name="line.12"></a>
<FONT color="green">013</FONT>     *     * Redistributions in binary form must reproduce the above copyright <a name="line.13"></a>
<FONT color="green">014</FONT>     *       notice, this list of conditions and the following disclaimer in the <a name="line.14"></a>
<FONT color="green">015</FONT>     *       documentation and/or other materials provided with the distribution.<a name="line.15"></a>
<FONT color="green">016</FONT>     *     * Neither the name of the Swiss Federal Institute of Technology Zurich <a name="line.16"></a>
<FONT color="green">017</FONT>     *       nor the names of its contributors may be used to endorse or promote <a name="line.17"></a>
<FONT color="green">018</FONT>     *       products derived from this software without specific prior written <a name="line.18"></a>
<FONT color="green">019</FONT>     *       permission.<a name="line.19"></a>
<FONT color="green">020</FONT>     * <a name="line.20"></a>
<FONT color="green">021</FONT>     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" <a name="line.21"></a>
<FONT color="green">022</FONT>     * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE <a name="line.22"></a>
<FONT color="green">023</FONT>     * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE <a name="line.23"></a>
<FONT color="green">024</FONT>     * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE <a name="line.24"></a>
<FONT color="green">025</FONT>     * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR <a name="line.25"></a>
<FONT color="green">026</FONT>     * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF <a name="line.26"></a>
<FONT color="green">027</FONT>     * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS <a name="line.27"></a>
<FONT color="green">028</FONT>     * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN <a name="line.28"></a>
<FONT color="green">029</FONT>     * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) <a name="line.29"></a>
<FONT color="green">030</FONT>     * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE <a name="line.30"></a>
<FONT color="green">031</FONT>     * POSSIBILITY OF SUCH DAMAGE.<a name="line.31"></a>
<FONT color="green">032</FONT>     * =============================================================================<a name="line.32"></a>
<FONT color="green">033</FONT>     */<a name="line.33"></a>
<FONT color="green">034</FONT>    package ch.javasoft.polco;<a name="line.34"></a>
<FONT color="green">035</FONT>    <a name="line.35"></a>
<FONT color="green">036</FONT>    import java.io.Writer;<a name="line.36"></a>
<FONT color="green">037</FONT>    <a name="line.37"></a>
<FONT color="green">038</FONT>    import ch.javasoft.math.linalg.LinAlgOperations;<a name="line.38"></a>
<FONT color="green">039</FONT>    <a name="line.39"></a>
<FONT color="green">040</FONT>    /**<a name="line.40"></a>
<FONT color="green">041</FONT>     * The &lt;code&gt;PolyhedralCone&lt;/code&gt; represents a general polyhedral cone <a name="line.41"></a>
<FONT color="green">042</FONT>     * &lt;i&gt;P&lt;/i&gt; in hyperplane and halfspace representation, that is, <a name="line.42"></a>
<FONT color="green">043</FONT>     * &lt;pre&gt;<a name="line.43"></a>
<FONT color="green">044</FONT>     * P = { A x = 0 , B x &amp;ge; 0 }<a name="line.44"></a>
<FONT color="green">045</FONT>     * &lt;/pre&gt;<a name="line.45"></a>
<FONT color="green">046</FONT>     * <a name="line.46"></a>
<FONT color="green">047</FONT>     * @type Num    the number type of a single number<a name="line.47"></a>
<FONT color="green">048</FONT>     * @type Arr    the number type of an array of numbers<a name="line.48"></a>
<FONT color="green">049</FONT>     */<a name="line.49"></a>
<FONT color="green">050</FONT>    public interface PolyhedralCone&lt;Num extends Number, Arr&gt; extends Numeric&lt;Num, Arr&gt; {<a name="line.50"></a>
<FONT color="green">051</FONT>            /**<a name="line.51"></a>
<FONT color="green">052</FONT>             * Returns the matrix A corresponding to the equalities in the definition of<a name="line.52"></a>
<FONT color="green">053</FONT>             * the polyhedral cone.<a name="line.53"></a>
<FONT color="green">054</FONT>             * <a name="line.54"></a>
<FONT color="green">055</FONT>             * @return      a two dimensional array representing the equality matrix, <a name="line.55"></a>
<FONT color="green">056</FONT>             *                      where the first dimension enumerates rows, the second columns<a name="line.56"></a>
<FONT color="green">057</FONT>             */<a name="line.57"></a>
<FONT color="green">058</FONT>            Arr[] getA();<a name="line.58"></a>
<FONT color="green">059</FONT>            /**<a name="line.59"></a>
<FONT color="green">060</FONT>             * Returns the matrix B corresponding to the inequalities in the definition <a name="line.60"></a>
<FONT color="green">061</FONT>             * of the polyhedral cone.<a name="line.61"></a>
<FONT color="green">062</FONT>             * <a name="line.62"></a>
<FONT color="green">063</FONT>             * @return      a two dimensional array representing the inequality matrix, <a name="line.63"></a>
<FONT color="green">064</FONT>             *                      where the first dimension enumerates rows, the second columns<a name="line.64"></a>
<FONT color="green">065</FONT>             */<a name="line.65"></a>
<FONT color="green">066</FONT>            Arr[] getB();<a name="line.66"></a>
<FONT color="green">067</FONT>            /**<a name="line.67"></a>
<FONT color="green">068</FONT>             * Returns a single number of the equality matrix A<a name="line.68"></a>
<FONT color="green">069</FONT>             */<a name="line.69"></a>
<FONT color="green">070</FONT>            Num getA(int row, int col);<a name="line.70"></a>
<FONT color="green">071</FONT>            /**<a name="line.71"></a>
<FONT color="green">072</FONT>             * Returns a single number of the inequality matrix B<a name="line.72"></a>
<FONT color="green">073</FONT>             */<a name="line.73"></a>
<FONT color="green">074</FONT>            Num getB(int row, int col);<a name="line.74"></a>
<FONT color="green">075</FONT>            /**<a name="line.75"></a>
<FONT color="green">076</FONT>             * Returns the number of equalities, that is, the number of rows in A<a name="line.76"></a>
<FONT color="green">077</FONT>             */<a name="line.77"></a>
<FONT color="green">078</FONT>            int getRowCountA();<a name="line.78"></a>
<FONT color="green">079</FONT>            /**<a name="line.79"></a>
<FONT color="green">080</FONT>             * Returns the number inequalities, that is, the number of rows in B<a name="line.80"></a>
<FONT color="green">081</FONT>             */<a name="line.81"></a>
<FONT color="green">082</FONT>            int getRowCountB();<a name="line.82"></a>
<FONT color="green">083</FONT>            /**<a name="line.83"></a>
<FONT color="green">084</FONT>             * Returns the number dimensions, that is, the size of the vector x or<a name="line.84"></a>
<FONT color="green">085</FONT>             * equivalently, the number of columns in A and B<a name="line.85"></a>
<FONT color="green">086</FONT>             */<a name="line.86"></a>
<FONT color="green">087</FONT>            int getDimensions();<a name="line.87"></a>
<FONT color="green">088</FONT>            /**<a name="line.88"></a>
<FONT color="green">089</FONT>             * Returns the operations object used to perform basic mathematical and<a name="line.89"></a>
<FONT color="green">090</FONT>             * linear algebra computations on the number type used for this cone <a name="line.90"></a>
<FONT color="green">091</FONT>             */<a name="line.91"></a>
<FONT color="green">092</FONT>            LinAlgOperations&lt;Num, Arr&gt; getLinAlgOperations();<a name="line.92"></a>
<FONT color="green">093</FONT>            <a name="line.93"></a>
<FONT color="green">094</FONT>            /**<a name="line.94"></a>
<FONT color="green">095</FONT>             * Returns a hash code created by combining all values of the matrices <a name="line.95"></a>
<FONT color="green">096</FONT>             * {@link #getA() A} and {@link #getB()} using the XOR function.<a name="line.96"></a>
<FONT color="green">097</FONT>             */<a name="line.97"></a>
<FONT color="green">098</FONT>            int hashCode();<a name="line.98"></a>
<FONT color="green">099</FONT>    <a name="line.99"></a>
<FONT color="green">100</FONT>            /**<a name="line.100"></a>
<FONT color="green">101</FONT>             * Returns true if the other object {@code obj} is a {@link PolyhedralCone} <a name="line.101"></a>
<FONT color="green">102</FONT>             * instance and if both matrices {@link #getA() A} and {@link #getB()} of <a name="line.102"></a>
<FONT color="green">103</FONT>             * the two cones are equal.<a name="line.103"></a>
<FONT color="green">104</FONT>             */<a name="line.104"></a>
<FONT color="green">105</FONT>            @Override<a name="line.105"></a>
<FONT color="green">106</FONT>            boolean equals(Object obj);<a name="line.106"></a>
<FONT color="green">107</FONT>            <a name="line.107"></a>
<FONT color="green">108</FONT>            /**<a name="line.108"></a>
<FONT color="green">109</FONT>             * Returns a verbose string representation of this polyhedral cone, <a name="line.109"></a>
<FONT color="green">110</FONT>             * including the matrix values and spanning multiple lines.<a name="line.110"></a>
<FONT color="green">111</FONT>             * &lt;p&gt;<a name="line.111"></a>
<FONT color="green">112</FONT>             * If both matrices are non-empty, the returned string looks for instance as <a name="line.112"></a>
<FONT color="green">113</FONT>             * follows:<a name="line.113"></a>
<FONT color="green">114</FONT>             * &lt;pre&gt;<a name="line.114"></a>
<FONT color="green">115</FONT>             * P = { A x = 0 , B x &gt;= 0 }<a name="line.115"></a>
<FONT color="green">116</FONT>             * A = 7x2 {<a name="line.116"></a>
<FONT color="green">117</FONT>             *   [ 1 , 1 ]<a name="line.117"></a>
<FONT color="green">118</FONT>             *   [ -1 , 1 ]<a name="line.118"></a>
<FONT color="green">119</FONT>             *   [ 0 , -3 ]<a name="line.119"></a>
<FONT color="green">120</FONT>             *   [ 1 , 1 ]<a name="line.120"></a>
<FONT color="green">121</FONT>             *   [ 0 , -3 ]<a name="line.121"></a>
<FONT color="green">122</FONT>             *   [ -1 , -1/2 ]<a name="line.122"></a>
<FONT color="green">123</FONT>             *   [ 1/2 , -1/2 ]<a name="line.123"></a>
<FONT color="green">124</FONT>             * }<a name="line.124"></a>
<FONT color="green">125</FONT>             * B = 5x2 {<a name="line.125"></a>
<FONT color="green">126</FONT>             *   [ 0 , -3 ]<a name="line.126"></a>
<FONT color="green">127</FONT>             *   [ 1 , 1 ]<a name="line.127"></a>
<FONT color="green">128</FONT>             *   [ -1 , 1 ]<a name="line.128"></a>
<FONT color="green">129</FONT>             *   [ 1/2 , -1/2 ]<a name="line.129"></a>
<FONT color="green">130</FONT>             *   [ 1 , 1 ]<a name="line.130"></a>
<FONT color="green">131</FONT>             * }<a name="line.131"></a>
<FONT color="green">132</FONT>             * &lt;/pre&gt;<a name="line.132"></a>
<FONT color="green">133</FONT>             */<a name="line.133"></a>
<FONT color="green">134</FONT>            void writeToMultiline(Writer writer);<a name="line.134"></a>
<FONT color="green">135</FONT>            <a name="line.135"></a>
<FONT color="green">136</FONT>            /**<a name="line.136"></a>
<FONT color="green">137</FONT>             * Writes a verbose string representation of this polyhedral cone using the<a name="line.137"></a>
<FONT color="green">138</FONT>             * specified {@code writer}. The output includes the matrix values and spans<a name="line.138"></a>
<FONT color="green">139</FONT>             * multiple lines.<a name="line.139"></a>
<FONT color="green">140</FONT>             * &lt;p&gt;<a name="line.140"></a>
<FONT color="green">141</FONT>             * If both matrices are non-empty, the written string looks for instance as <a name="line.141"></a>
<FONT color="green">142</FONT>             * follows:<a name="line.142"></a>
<FONT color="green">143</FONT>             * &lt;pre&gt;<a name="line.143"></a>
<FONT color="green">144</FONT>             * P = { A x = 0 , B x &gt;= 0 }<a name="line.144"></a>
<FONT color="green">145</FONT>             * A = 7x2 {<a name="line.145"></a>
<FONT color="green">146</FONT>             *   [ 1 , 1 ]<a name="line.146"></a>
<FONT color="green">147</FONT>             *   [ -1 , 1 ]<a name="line.147"></a>
<FONT color="green">148</FONT>             *   [ 0 , -3 ]<a name="line.148"></a>
<FONT color="green">149</FONT>             *   [ 1 , 1 ]<a name="line.149"></a>
<FONT color="green">150</FONT>             *   [ 0 , -3 ]<a name="line.150"></a>
<FONT color="green">151</FONT>             *   [ -1 , -1/2 ]<a name="line.151"></a>
<FONT color="green">152</FONT>             *   [ 1/2 , -1/2 ]<a name="line.152"></a>
<FONT color="green">153</FONT>             * }<a name="line.153"></a>
<FONT color="green">154</FONT>             * B = 5x2 {<a name="line.154"></a>
<FONT color="green">155</FONT>             *   [ 0 , -3 ]<a name="line.155"></a>
<FONT color="green">156</FONT>             *   [ 1 , 1 ]<a name="line.156"></a>
<FONT color="green">157</FONT>             *   [ -1 , 1 ]<a name="line.157"></a>
<FONT color="green">158</FONT>             *   [ 1/2 , -1/2 ]<a name="line.158"></a>
<FONT color="green">159</FONT>             *   [ 1 , 1 ]<a name="line.159"></a>
<FONT color="green">160</FONT>             * }<a name="line.160"></a>
<FONT color="green">161</FONT>             * &lt;/pre&gt;<a name="line.161"></a>
<FONT color="green">162</FONT>             */<a name="line.162"></a>
<FONT color="green">163</FONT>            String toMultilineString();<a name="line.163"></a>
<FONT color="green">164</FONT>            <a name="line.164"></a>
<FONT color="green">165</FONT>            /**<a name="line.165"></a>
<FONT color="green">166</FONT>             * Returns a short string representation of this polyhedral cone, without<a name="line.166"></a>
<FONT color="green">167</FONT>             * matrix values, but including matrix dimensions.<a name="line.167"></a>
<FONT color="green">168</FONT>             * &lt;p&gt;<a name="line.168"></a>
<FONT color="green">169</FONT>             * If both matrices are non-empty, the returned string looks for instance as <a name="line.169"></a>
<FONT color="green">170</FONT>             * follows:<a name="line.170"></a>
<FONT color="green">171</FONT>             * &lt;pre&gt;<a name="line.171"></a>
<FONT color="green">172</FONT>             * P = { A x = 0 , B x &gt;= 0 , A:7x2 , B:5x2 }<a name="line.172"></a>
<FONT color="green">173</FONT>             * &lt;/pre&gt;<a name="line.173"></a>
<FONT color="green">174</FONT>             */<a name="line.174"></a>
<FONT color="green">175</FONT>            String toString();<a name="line.175"></a>
<FONT color="green">176</FONT>            <a name="line.176"></a>
<FONT color="green">177</FONT>    }<a name="line.177"></a>




























































</PRE>
</BODY>
</HTML>
